// Generated by 'peg2'
// https://pub.dev/packages/peg2

void main() {
  final parser = ExampleParser();
  final result = parser.parse(_text);
  if (parser.error != null) {
    throw parser.error;
  }

  print(result);
}

final _text = '''
{"rocket": "🚀 flies to the stars"}
''';

class ExampleParser {
  static const _eof = 0x110000;

  FormatException error;

  int _c;

  List<String> _failures;

  int _fcount;

  int _fposEnd;

  int _fposMax;

  int _fposStart;

  List<int> _input;

  List<bool> _memoizable;

  List<List<_Memo>> _memos;

  var _mresult;

  int _pos;

  bool _predicate;

  dynamic _result;

  bool _silence;

  bool _success;

  String _text;

  List<int> _trackCid;

  List<int> _trackPos;

  dynamic parse(String text) {
    if (text == null) {
      throw ArgumentError.notNull('text');
    }
    _text = text;
    _input = _toRunes(text);
    _reset();
    final result = _parseJson(0, true);
    _buildError();
    _failures = null;
    _input = null;
    return result;
  }

  void _buildError() {
    if (_success) {
      error = null;
      return;
    }

    String escape(int c) {
      switch (c) {
        case 10:
          return r'\n';
        case 13:
          return r'\r';
        case 09:
          return r'\t';
        case _eof:
          return 'end of file';
      }
      return String.fromCharCode(c);
    }

    String getc(int position) {
      if (position < _text.length) {
        return "'${escape(_input[position])}'";
      }
      return 'end of file';
    }

    String report(String message, String source, int start) {
      if (start < 0 || start > source.length) {
        start = null;
      }

      final sb = StringBuffer();
      sb.write(message);
      var line = 0;
      var col = 0;
      var lineStart = 0;
      var started = false;
      if (start != null) {
        for (var i = 0; i < source.length; i++) {
          final c = source.codeUnitAt(i);
          if (!started) {
            started = true;
            lineStart = i;
            line++;
            col = 1;
          } else {
            col++;
          }
          if (c == 10) {
            started = false;
          }
          if (start == i) {
            break;
          }
        }
      }

      if (start == null) {
        sb.writeln('.');
      } else if (line == 0 || start == source.length) {
        sb.writeln(' (at end of file):');
      } else {
        sb.write(' (at line ');
        sb.write(line);
        sb.write(', column ');
        sb.write(col);
        sb.writeln('):');
      }

      List<int> escape(int c) {
        switch (c) {
          case 9:
            return [92, 116];
          case 10:
            return [92, 110];
          case 13:
            return [92, 114];
          default:
            return [c];
        }
      }

      const max = 70;
      if (start != null) {
        final c1 = <int>[];
        final c2 = <int>[];
        final half = max ~/ 2;
        var cr = false;
        for (var i = start; i >= lineStart && c1.length < half; i--) {
          if (i == source.length) {
            c2.insert(0, 94);
          } else {
            final c = source.codeUnitAt(i);
            final escaped = escape(c);
            c1.insertAll(0, escaped);
            if (c == 10) {
              cr = true;
            }

            var r = i == start ? 94 : 32;
            for (var k = 0; k < escaped.length; k++) {
              c2.insert(0, r);
            }
          }
        }

        for (var i = start + 1;
            i < source.length && c1.length < max && !cr;
            i++) {
          final c = source.codeUnitAt(i);
          final escaped = escape(c);
          c1.addAll(escaped);
          if (c == 10) {
            break;
          }
        }

        var text1 = String.fromCharCodes(c1);
        var text2 = String.fromCharCodes(c2);
        sb.writeln(text1);
        sb.writeln(text2);
      }

      return sb.toString();
    }

    final temp = _failures.take(_fcount).toList();
    temp.sort((e1, e2) => e1.compareTo(e2));
    final terminals = temp.toSet();
    final hasMalformed = _fposStart != _fposMax;
    if (terminals.isNotEmpty) {
      if (!hasMalformed) {
        final sb = StringBuffer();
        sb.write('Expected ');
        sb.write(terminals.join(', '));
        sb.write(' but found ');
        sb.write(getc(_fposStart));
        final title = sb.toString();
        final message = report(title, _text, _fposStart);
        error = FormatException(message);
      } else {
        final reason = _fposMax == _text.length ? 'Unterminated' : 'Malformed';
        final sb = StringBuffer();
        sb.write(reason);
        sb.write(' ');
        sb.write(terminals.join(', '));
        final title = sb.toString();
        final message = report(title, _text, _fposStart);
        error = FormatException(message);
      }
    } else {
      final sb = StringBuffer();
      sb.write('Unexpected character ');
      sb.write(getc(_fposStart));
      final title = sb.toString();
      final message = report(title, _text, _fposStart);
      error = FormatException(message);
    }
  }

  void _fail(int start, String name) {
    if (_fposStart < start) {
      _fposStart = start;
      _fposMax = _fposEnd;
      _fcount = 0;
    } else if (_fposMax < _fposEnd) {
      _fposStart = start;
      _fposMax = _fposEnd;
      _fcount = 0;
    }

    if (_fposStart == start && _fposEnd == _fposMax) {
      if (_fcount >= _failures.length) {
        _failures.length += 20;
      }

      _failures[_fcount++] = name;
    }
  }

  int _matchRanges(List<int> ranges) {
    int result;
    _success = false;
    for (var i = 0; i < ranges.length; i += 2) {
      if (ranges[i] <= _c) {
        if (ranges[i + 1] >= _c) {
          result = _c;
          _c = _input[_pos += _c <= 0xffff ? 1 : 2];
          _success = true;
          break;
        }
      } else {
        break;
      }
    }

    if (!_success && !_silence && _fposEnd < _pos) {
      _fposEnd = _pos;
    }

    return result;
  }

  String _matchString(String text) {
    String result;
    final length = text.length;
    final rest = _text.length - _pos;
    final count = length > rest ? rest : length;
    var pos = _pos;
    var i = 0;
    for (; i < count; i++, pos++) {
      if (text.codeUnitAt(i) != _text.codeUnitAt(pos)) {
        break;
      }
    }

    if (i == length) {
      _c = _input[_pos += length];
      _success = true;
      result = text;
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos + i;
      }
    }

    return result;
  }

  bool _memoized(int id, int cid) {
    final memos = _memos[_pos];
    if (memos != null) {
      for (var i = 0; i < memos.length; i++) {
        final memo = memos[i];
        if (memo.id == id) {
          _pos = memo.pos;
          _mresult = memo.result;
          _success = memo.success;
          _c = _input[_pos];
          return true;
        }
      }
    }

    if (_memoizable[cid] != null) {
      return false;
    }

    var lastCid = _trackCid[id];
    var lastPos = _trackPos[id];
    _trackCid[id] = cid;
    _trackPos[id] = _pos;
    if (lastCid == null) {
      return false;
    }

    if (lastPos == _pos) {
      if (lastCid != cid) {
        _memoizable[lastCid] = true;
        _memoizable[cid] = false;
      }
    }

    return false;
  }

  void _memoize(int id, int pos, result) {
    var memos = _memos[pos];
    if (memos == null) {
      memos = [];
      _memos[pos] = memos;
    }

    final memo = _Memo(
      id: id,
      pos: _pos,
      result: result,
      success: _success,
    );

    memos.add(memo);
  }

  void _reset() {
    _c = _input[0];
    _failures = [];
    _failures.length = 20;
    _fcount = 0;
    _fposEnd = -1;
    _fposMax = -1;
    _fposStart = -1;
    _memoizable = [];
    _memoizable.length = 187;
    _memos = [];
    _memos.length = _input.length + 1;
    _pos = 0;
    _predicate = false;
    _silence = false;
    _trackCid = [];
    _trackCid.length = 187;
    _trackPos = [];
    _trackPos.length = 187;
  }

  List<int> _toRunes(String source) {
    final length = source.length;
    final result = List<int>(length + 1);
    for (var pos = 0; pos < length;) {
      int c;
      final start = pos;
      final leading = source.codeUnitAt(pos++);
      if ((leading & 0xFC00) == 0xD800 && pos < length) {
        final trailing = source.codeUnitAt(pos);
        if ((trailing & 0xFC00) == 0xDC00) {
          c = 0x10000 + ((leading & 0x3FF) << 10) + (trailing & 0x3FF);
          pos++;
        } else {
          c = leading;
        }
      } else {
        c = leading;
      }

      result[start] = c;
    }

    result[length] = 0x110000;
    return result;
  }

  dynamic _parseJson(int $0, bool $1) {
    dynamic $2;
    var $5 = _c;
    var $6 = _pos;
    var $7 = _silence;
    _silence = true;
    if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
      _parse_leading_spaces(3, false);
    } else {
      _success = true;
    }
    _success = true;
    _silence = $7;
    $2 = _parseValue(4, $1);
    if (_success) {
      if (_c >= 0 && _c <= 1114112) {
        _parse_end_of_file(5, false);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'end of file\'');
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  dynamic _parseValue(int $0, bool $1) {
    dynamic $2;
    for (;;) {
      $2 = _parseArray(8, $1);
      if (_success) {
        break;
      }
      if (_c == 102) {
        $2 = _parse_false(10, $1);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'false\'');
        }
      }
      if (_success) {
        break;
      }
      if (_c == 110) {
        $2 = _parse_null(12, $1);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'null\'');
        }
      }
      if (_success) {
        break;
      }
      if (_c == 116) {
        $2 = _parse_true(14, $1);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'true\'');
        }
      }
      if (_success) {
        break;
      }
      $2 = _parseObject(16, $1);
      if (_success) {
        break;
      }
      if (_c == 45 || _c >= 48 && _c <= 57) {
        $2 = _parse_number(18, $1);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'number\'');
        }
      }
      if (_success) {
        break;
      }
      if (_c == 34) {
        $2 = _parse_string(20, $1);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'string\'');
        }
      }
      break;
    }
    return $2;
  }

  List _parseArray(int $0, bool $1) {
    List $2;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 91) {
      _parse_$LeftSquareBracket(23, false);
    } else {
      _success = false;
      if (!_silence) {
        _fposEnd = _pos;
        _fail(_pos, '\'[\'');
      }
    }
    if (_success) {
      var $9 = _silence;
      _silence = true;
      var $10 = _parseValues(25, $1);
      _success = true;
      _silence = $9;
      if (_c == 93) {
        _parse_$RightSquareBracket(26, false);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\']\'');
        }
      }
      if (_success) {
        var v = $10;
        List $$;
        $$ = v ?? [];
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  List _parseValues(int $0, bool $1) {
    List $2;
    var $5 = _c;
    var $6 = _pos;
    var $7 = _parseValue(29, $1);
    if (_success) {
      List $8;
      var $9 = _silence;
      _silence = true;
      if ($1) {
        $8 = [];
      }
      for (;;) {
        dynamic $10;
        var $12 = _c;
        var $13 = _pos;
        if (_c == 44) {
          _parse_$Comma(33, false);
        } else {
          _success = false;
          if (!_silence) {
            _fposEnd = _pos;
            _fail(_pos, '\',\'');
          }
        }
        if (_success) {
          $10 = _parseValue(34, $1);
        }
        if (!_success) {
          _c = $12;
          _pos = $13;
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $8.add($10);
        }
      }
      _success = true;
      _silence = $9;
      if (_success) {
        var v = $7;
        var n = $8;
        List $$;
        $$ = [v, ...n];
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  Map<String, dynamic> _parseObject(int $0, bool $1) {
    Map<String, dynamic> $2;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 123) {
      _parse_$LeftBrace(37, false);
    } else {
      _success = false;
      if (!_silence) {
        _fposEnd = _pos;
        _fail(_pos, '\'{\'');
      }
    }
    if (_success) {
      var $9 = _silence;
      _silence = true;
      var $10 = _parseMembers(39, $1);
      _success = true;
      _silence = $9;
      if (_c == 125) {
        _parse_$RightBrace(40, false);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\'}\'');
        }
      }
      if (_success) {
        var m = $10;
        Map<String, dynamic> $$;
        $$ = <String, dynamic>{}..addEntries(m ?? []);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  List<MapEntry<String, dynamic>> _parseMembers(int $0, bool $1) {
    List<MapEntry<String, dynamic>> $2;
    var $5 = _c;
    var $6 = _pos;
    var $7 = _parseMember(43, $1);
    if (_success) {
      List<MapEntry<String, dynamic>> $8;
      var $9 = _silence;
      _silence = true;
      if ($1) {
        $8 = [];
      }
      for (;;) {
        MapEntry<String, dynamic> $10;
        var $12 = _c;
        var $13 = _pos;
        if (_c == 44) {
          _parse_$Comma(47, false);
        } else {
          _success = false;
          if (!_silence) {
            _fposEnd = _pos;
            _fail(_pos, '\',\'');
          }
        }
        if (_success) {
          $10 = _parseMember(48, $1);
        }
        if (!_success) {
          _c = $12;
          _pos = $13;
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $8.add($10);
        }
      }
      _success = true;
      _silence = $9;
      if (_success) {
        var m = $7;
        var n = $8;
        List<MapEntry<String, dynamic>> $$;
        $$ = [m, ...n];
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  MapEntry<String, dynamic> _parseMember(int $0, bool $1) {
    MapEntry<String, dynamic> $2;
    var $5 = _c;
    var $6 = _pos;
    String $7;
    if (_c == 34) {
      $7 = _parse_string(51, $1);
    } else {
      _success = false;
      if (!_silence) {
        _fposEnd = _pos;
        _fail(_pos, '\'string\'');
      }
    }
    if (_success) {
      if (_c == 58) {
        _parse_$Colon(52, false);
      } else {
        _success = false;
        if (!_silence) {
          _fposEnd = _pos;
          _fail(_pos, '\':\'');
        }
      }
      if (_success) {
        var $11 = _parseValue(53, $1);
        if (_success) {
          var k = $7;
          var v = $11;
          MapEntry<String, dynamic> $$;
          $$ = MapEntry(k, v);
          $2 = $$;
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  dynamic _parse_end_of_file(int $0, bool $1) {
    dynamic $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    var $8 = _predicate;
    var $9 = _silence;
    var $10 = $1;
    _predicate = true;
    $1 = false;
    _silence = true;
    if (_c < _eof) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    _silence = $9;
    _c = $6;
    _pos = $7;
    _predicate = $8;
    _silence = $9;
    $1 = $10;
    _success = !_success;
    if (!_silence && !_success) {
      _fail($4, '\'end of file\'');
    }
    return $2;
  }

  dynamic _parse_false(int $0, bool $1) {
    dynamic $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 102) {
      _success = true;
      _matchString('false');
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(61, false);
      } else {
        _success = true;
      }
      if (_success) {
        dynamic $$;
        $$ = false;
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'false\'');
    }
    return $2;
  }

  List<int> _parse_leading_spaces(int $0, bool $1) {
    List<int> $2;
    _fposEnd = -1;
    var $4 = _pos;
    if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
      $2 = _parse$$spacing(64, false);
    } else {
      _success = true;
    }
    if (!_silence && !_success) {
      _fail($4, '\'leading spaces\'');
    }
    return $2;
  }

  dynamic _parse_null(int $0, bool $1) {
    dynamic $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 110) {
      _success = true;
      _matchString('null');
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(68, false);
      } else {
        _success = true;
      }
      if (_success) {
        dynamic $$;
        $$ = null;
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'null\'');
    }
    return $2;
  }

  dynamic _parse_true(int $0, bool $1) {
    dynamic $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 116) {
      _success = true;
      _matchString('true');
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(72, false);
      } else {
        _success = true;
      }
      if (_success) {
        dynamic $$;
        $$ = true;
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'true\'');
    }
    return $2;
  }

  String _parse_string(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 34) {
      _success = true;
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      List<int> $9;
      var $10 = _silence;
      _silence = true;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        int $11;
        if (_c >= 32 && _c <= 33 || _c >= 35 && _c <= 1114111) {
          $11 = _parse$$char(77, $1);
        } else {
          _success = false;
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $9.add($11);
        }
      }
      _success = true;
      _silence = $10;
      if (_c == 34) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
          _parse$$spacing(79, false);
        } else {
          _success = true;
        }
        if (_success) {
          var c = $9;
          String $$;
          $$ = String.fromCharCodes(c);
          $2 = $$;
        }
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'string\'');
    }
    return $2;
  }

  num _parse_number(int $0, bool $1) {
    num $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    String $8;
    var $9 = _pos;
    var $10 = $1;
    $1 = false;
    var $13 = _c;
    var $14 = _pos;
    var $15 = _silence;
    _silence = true;
    if (_c == 45) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    _success = true;
    _silence = $15;
    for (;;) {
      if (_c == 48) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      var $21 = _c;
      var $22 = _pos;
      if (_c >= 49 && _c <= 57) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        var $25 = _silence;
        _silence = true;
        for (;;) {
          if (_c >= 48 && _c <= 57) {
            _success = true;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
          if (!_success) {
            break;
          }
        }
        _success = true;
        _silence = $25;
      }
      if (!_success) {
        _c = $21;
        _pos = $22;
      }
      break;
    }
    if (_success) {
      var $27 = _silence;
      _silence = true;
      var $30 = _c;
      var $31 = _pos;
      if (_c == 46) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        var $34 = false;
        for (;;) {
          if (_c >= 48 && _c <= 57) {
            _success = true;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
          if (!_success) {
            _success = $34;
            break;
          }
          $34 = true;
        }
      }
      if (!_success) {
        _c = $30;
        _pos = $31;
      }
      _success = true;
      _silence = $27;
      var $36 = _silence;
      _silence = true;
      var $39 = _c;
      var $40 = _pos;
      if (_c == 69 || _c == 101) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        var $43 = false;
        for (;;) {
          if (_c == 32 || _c >= 43 && _c <= 93) {
            _success = true;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
          if (!_success) {
            _success = $43;
            break;
          }
          $43 = true;
        }
      }
      if (!_success) {
        _c = $39;
        _pos = $40;
      }
      _success = true;
      _silence = $36;
    }
    if (!_success) {
      _c = $13;
      _pos = $14;
    }
    if (_success) {
      $8 = _text.substring($9, _pos);
    }
    $1 = $10;
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(106, false);
      } else {
        _success = true;
      }
      if (_success) {
        var n = $8;
        num $$;
        $$ = num.parse(n);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'number\'');
    }
    return $2;
  }

  String _parse_$LeftBrace(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 123) {
      _success = true;
      $2 = '{';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(110, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'{\'');
    }
    return $2;
  }

  String _parse_$RightBrace(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 125) {
      _success = true;
      $2 = '}';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(114, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'}\'');
    }
    return $2;
  }

  String _parse_$LeftSquareBracket(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 91) {
      _success = true;
      $2 = '[';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(118, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\'[\'');
    }
    return $2;
  }

  String _parse_$RightSquareBracket(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 93) {
      _success = true;
      $2 = ']';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(122, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\']\'');
    }
    return $2;
  }

  String _parse_$Comma(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 44) {
      _success = true;
      $2 = ',';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(126, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\',\'');
    }
    return $2;
  }

  String _parse_$Colon(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _pos;
    var $6 = _c;
    var $7 = _pos;
    if (_c == 58) {
      _success = true;
      $2 = ':';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _parse$$spacing(130, false);
      } else {
        _success = true;
      }
    }
    if (!_success) {
      _c = $6;
      _pos = $7;
    }
    if (!_silence && !_success) {
      _fail($4, '\':\'');
    }
    return $2;
  }

  int _parse$$digit(int $0, bool $1) {
    int $2;
    if (_c >= 48 && _c <= 57) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      int $$;
      $$ = $$ - 48;
      $2 = $$;
    }
    return $2;
  }

  int _parse$$digit1_9(int $0, bool $1) {
    int $2;
    if (_c >= 49 && _c <= 57) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      int $$;
      $$ = $$ - 48;
      $2 = $$;
    }
    return $2;
  }

  int _parse$$char(int $0, bool $1) {
    int $2;
    for (;;) {
      var $5 = _c;
      var $6 = _pos;
      if (_c == 92) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        if (_c == 34 ||
            _c == 47 ||
            _c == 92 ||
            _c == 98 ||
            _c == 102 ||
            _c == 110 ||
            _c == 114 ||
            _c >= 116 && _c <= 117) {
          $2 = _parse$$escaped(140, $1);
        } else {
          _success = false;
        }
      }
      if (!_success) {
        _c = $5;
        _pos = $6;
      } else {
        break;
      }
      if (_c >= 32 && _c <= 33 ||
          _c >= 35 && _c <= 91 ||
          _c >= 93 && _c <= 1114111) {
        $2 = _parse$$unescaped(142, $1);
      } else {
        _success = false;
      }
      break;
    }
    return $2;
  }

  int _parse$$escaped(int $0, bool $1) {
    int $2;
    for (;;) {
      if (_c == 34) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      if (_c == 92) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      if (_c == 47) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      if (_c == 98) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = 0x8;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c == 102) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = 0xC;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c == 110) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = 0xA;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c == 114) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = 0xD;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c == 116) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = 0x9;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      var $21 = _c;
      var $22 = _pos;
      if (_c == 117) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        if (_c >= 48 && _c <= 57 ||
            _c >= 65 && _c <= 70 ||
            _c >= 97 && _c <= 102) {
          $2 = _parse$$hexdig4(162, $1);
        } else {
          _success = false;
        }
      }
      if (!_success) {
        _c = $21;
        _pos = $22;
      }
      break;
    }
    return $2;
  }

  int _parse$$hexdig4(int $0, bool $1) {
    int $2;
    var $5 = _c;
    var $6 = _pos;
    int $7;
    if (_c >= 48 && _c <= 57 || _c >= 65 && _c <= 70 || _c >= 97 && _c <= 102) {
      $7 = _parse$$hexdig(165, $1);
    } else {
      _success = false;
    }
    if (_success) {
      int $9;
      if (_c >= 48 && _c <= 57 ||
          _c >= 65 && _c <= 70 ||
          _c >= 97 && _c <= 102) {
        $9 = _parse$$hexdig(166, $1);
      } else {
        _success = false;
      }
      if (_success) {
        int $11;
        if (_c >= 48 && _c <= 57 ||
            _c >= 65 && _c <= 70 ||
            _c >= 97 && _c <= 102) {
          $11 = _parse$$hexdig(167, $1);
        } else {
          _success = false;
        }
        if (_success) {
          int $13;
          if (_c >= 48 && _c <= 57 ||
              _c >= 65 && _c <= 70 ||
              _c >= 97 && _c <= 102) {
            $13 = _parse$$hexdig(168, $1);
          } else {
            _success = false;
          }
          if (_success) {
            var a = $7;
            var b = $9;
            var c = $11;
            var d = $13;
            int $$;
            $$ = a * 0xfff + b * 0xff + c * 0xf + d;
            $2 = $$;
          }
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    return $2;
  }

  int _parse$$hexdig(int $0, bool $1) {
    int $2;
    for (;;) {
      if (_c >= 97 && _c <= 102) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = $$ - 97;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c >= 65 && _c <= 70) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = $$ - 65;
        $2 = $$;
      }
      if (_success) {
        break;
      }
      if (_c >= 48 && _c <= 57) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $$;
        $$ = $$ - 48;
        $2 = $$;
      }
      break;
    }
    return $2;
  }

  int _parse$$unescaped(int $0, bool $1) {
    int $2;
    for (;;) {
      if (_c >= 32 && _c <= 33) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      if (_c >= 35 && _c <= 91) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      }
      if (_c >= 93 && _c <= 1114111) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      break;
    }
    return $2;
  }

  List<int> _parse$$spacing(int $0, bool $1) {
    List<int> $2;
    var $6 = _silence;
    _silence = true;
    for (;;) {
      if (_c >= 9 && _c <= 10 || _c == 13 || _c == 32) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (!_success) {
        break;
      }
    }
    _success = true;
    _silence = $6;
    return $2;
  }
}

class _Memo {
  final int id;

  final int pos;

  final result;

  final bool success;

  _Memo({
    this.id,
    this.pos,
    this.result,
    this.success,
  });
}
// ignore_for_file: prefer_final_locals
// ignore_for_file: unused_element
// ignore_for_file: unused_field
// ignore_for_file: unused_local_variable
